Index: uspace/lib/device/src/io/chardev_srv.c
===================================================================
--- uspace/lib/device/src/io/chardev_srv.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/src/io/chardev_srv.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2014 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -55,4 +55,5 @@
 	ipc_call_t call;
 	if (!async_data_read_receive(&call, &size)) {
+		async_answer_0(&call, EINVAL);
 		async_answer_0(icall, EINVAL);
 		return;
Index: uspace/lib/dispcfg/doc/doxygroups.h
===================================================================
--- uspace/lib/dispcfg/doc/doxygroups.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/dispcfg/doc/doxygroups.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,3 @@
+/** @addtogroup libdispcfg libdispcfg
+ * @ingroup libs
+ */
Index: uspace/lib/dispcfg/include/dispcfg.h
===================================================================
--- uspace/lib/dispcfg/include/dispcfg.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/dispcfg/include/dispcfg.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,60 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libdispcfg
+ * @{
+ */
+/** @file
+ */
+
+#ifndef _LIBDISPCFG_DISPCFG_H_
+#define _LIBDISPCFG_DISPCFG_H_
+
+#include <errno.h>
+#include <types/common.h>
+#include "types/dispcfg.h"
+
+extern errno_t dispcfg_open(const char *, dispcfg_cb_t *, void *, dispcfg_t **);
+extern void dispcfg_close(dispcfg_t *);
+extern errno_t dispcfg_get_seat_list(dispcfg_t *, dispcfg_seat_list_t **);
+extern void dispcfg_free_seat_list(dispcfg_seat_list_t *);
+extern errno_t dispcfg_get_seat_info(dispcfg_t *, sysarg_t,
+    dispcfg_seat_info_t **);
+extern void dispcfg_free_seat_info(dispcfg_seat_info_t *);
+extern errno_t dispcfg_seat_create(dispcfg_t *, const char *, sysarg_t *);
+extern errno_t dispcfg_seat_delete(dispcfg_t *, sysarg_t);
+extern errno_t dispcfg_dev_assign(dispcfg_t *, sysarg_t, sysarg_t);
+extern errno_t dispcfg_dev_unassign(dispcfg_t *, sysarg_t);
+extern errno_t dispcfg_get_asgn_dev_list(dispcfg_t *, sysarg_t,
+    dispcfg_dev_list_t **);
+extern void dispcfg_free_dev_list(dispcfg_dev_list_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/dispcfg/include/dispcfg_srv.h
===================================================================
--- uspace/lib/dispcfg/include/dispcfg_srv.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/dispcfg/include/dispcfg_srv.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,69 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libdispcfg
+ * @{
+ */
+/** @file
+ */
+
+#ifndef _LIBDISPCFG_DISPCFG_SRV_H_
+#define _LIBDISPCFG_DISPCFG_SRV_H_
+
+#include <async.h>
+#include <errno.h>
+#include "types/dispcfg.h"
+
+typedef struct dispcfg_ops dispcfg_ops_t;
+
+/** Display configuration server structure (per client session) */
+typedef struct {
+	async_sess_t *client_sess;
+	dispcfg_ops_t *ops;
+	void *arg;
+} dispcfg_srv_t;
+
+struct dispcfg_ops {
+	errno_t (*get_seat_list)(void *, dispcfg_seat_list_t **);
+	errno_t (*get_seat_info)(void *, sysarg_t, dispcfg_seat_info_t **);
+	errno_t (*seat_create)(void *, const char *, sysarg_t *);
+	errno_t (*seat_delete)(void *, sysarg_t);
+	errno_t (*dev_assign)(void *, sysarg_t, sysarg_t);
+	errno_t (*dev_unassign)(void *, sysarg_t);
+	errno_t (*get_asgn_dev_list)(void *, sysarg_t, dispcfg_dev_list_t **);
+	errno_t (*get_event)(void *, dispcfg_ev_t *);
+};
+
+extern void dispcfg_conn(ipc_call_t *, dispcfg_srv_t *);
+extern void dispcfg_srv_initialize(dispcfg_srv_t *);
+extern void dispcfg_srv_ev_pending(dispcfg_srv_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/dispcfg/include/ipc/dispcfg.h
===================================================================
--- uspace/lib/dispcfg/include/ipc/dispcfg.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/dispcfg/include/ipc/dispcfg.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,59 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libdispcfg
+ * @{
+ */
+/** @file
+ */
+
+#ifndef LIBDISPCFG_IPC_DISPCFG_H
+#define LIBDISPCFG_IPC_DISPCFG_H
+
+#include <ipc/common.h>
+
+typedef enum {
+	DISPCFG_CALLBACK_CREATE = IPC_FIRST_USER_METHOD,
+	DISPCFG_GET_SEAT_LIST,
+	DISPCFG_GET_SEAT_INFO,
+	DISPCFG_SEAT_CREATE,
+	DISPCFG_SEAT_DELETE,
+	DISPCFG_DEV_ASSIGN,
+	DISPCFG_DEV_UNASSIGN,
+	DISPCFG_GET_ASGN_DEV_LIST,
+	DISPCFG_GET_EVENT,
+} dispcfg_request_t;
+
+typedef enum {
+	DISPCFG_EV_PENDING = IPC_FIRST_USER_METHOD
+} dispcfg_event_t;
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/dispcfg/include/testdc.h
===================================================================
--- uspace/lib/dispcfg/include/testdc.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/dispcfg/include/testdc.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,48 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libdispcfg
+ * @{
+ */
+/** @file
+ */
+
+#ifndef _LIBDISPCFG_TESTDC_H_
+#define _LIBDISPCFG_TESTDC_H_
+
+#include <async.h>
+#include "types/testdc.h"
+
+extern dispcfg_cb_t test_dispcfg_cb;
+
+extern void test_dispcfg_conn(ipc_call_t *, void *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/dispcfg/include/types/dispcfg.h
===================================================================
--- uspace/lib/dispcfg/include/types/dispcfg.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/dispcfg/include/types/dispcfg.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,98 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libdispcfg
+ * @{
+ */
+/** @file Display configuration protocol types
+ */
+
+#ifndef _LIBDISPCFG_TYPES_DISPCFG_H_
+#define _LIBDISPCFG_TYPES_DISPCFG_H_
+
+#include <ipc/services.h>
+#include <types/common.h>
+
+/** Use the default display configuration service (argument to dispcfg_open() */
+#define DISPCFG_DEFAULT SERVICE_NAME_DISPCFG
+
+struct dispcfg;
+
+/** Display configuration session */
+typedef struct dispcfg dispcfg_t;
+
+/** Display configuration callbacks */
+typedef struct {
+	/** Seat added */
+	void (*seat_added)(void *, sysarg_t);
+	/** Seat removed */
+	void (*seat_removed)(void *, sysarg_t);
+} dispcfg_cb_t;
+
+/** Display configuration event type */
+typedef enum {
+	/** Seat added */
+	dcev_seat_added,
+	/** Seat removed */
+	dcev_seat_removed,
+} dispcfg_ev_type_t;
+
+/** Display configuration event */
+typedef struct {
+	/** Event type */
+	dispcfg_ev_type_t etype;
+	/** Seat ID */
+	sysarg_t seat_id;
+} dispcfg_ev_t;
+
+/** Seat list */
+typedef struct {
+	/** Number of seats */
+	size_t nseats;
+	/** ID for each seat */
+	sysarg_t *seats;
+} dispcfg_seat_list_t;
+
+/** Seat information */
+typedef struct {
+	/** Seat name */
+	char *name;
+} dispcfg_seat_info_t;
+
+/** Assigned device list */
+typedef struct {
+	/** Number of devices */
+	size_t ndevs;
+	/** ID for each device */
+	sysarg_t *devs;
+} dispcfg_dev_list_t;
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/dispcfg/include/types/testdc.h
===================================================================
--- uspace/lib/dispcfg/include/types/testdc.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/dispcfg/include/types/testdc.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,98 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libdispcfg
+ * @{
+ */
+/** @file Display configuration test service types
+ */
+
+#ifndef _LIBDISPCFG_TYPES_TESTDC_H_
+#define _LIBDISPCFG_TYPES_TESTDC_H_
+
+#include <errno.h>
+#include <fibril_synch.h>
+#include <stdbool.h>
+#include <types/common.h>
+#include <types/dispcfg.h>
+
+/** Describes to the server how to respond to our request and pass tracking
+ * data back to the client.
+ */
+typedef struct {
+	errno_t rc;
+	sysarg_t seat_id;
+	dispcfg_ev_t event;
+	dispcfg_ev_t revent;
+	int event_cnt;
+
+	bool get_seat_list_called;
+	dispcfg_seat_list_t *get_seat_list_rlist;
+
+	bool get_seat_info_called;
+	sysarg_t get_seat_info_seat_id;
+	dispcfg_seat_info_t *get_seat_info_rinfo;
+
+	bool seat_create_called;
+	char *seat_create_name;
+	sysarg_t seat_create_seat_id;
+
+	bool seat_delete_called;
+	sysarg_t seat_delete_seat_id;
+
+	bool dev_assign_called;
+	sysarg_t dev_assign_svc_id;
+	sysarg_t dev_assign_seat_id;
+
+	bool dev_unassign_called;
+	sysarg_t dev_unassign_svc_id;
+
+	bool get_asgn_dev_list_called;
+	sysarg_t get_asgn_dev_list_seat_id;
+	dispcfg_dev_list_t *get_asgn_dev_list_rlist;
+
+	bool get_event_called;
+
+	bool seat_added_called;
+	sysarg_t seat_added_seat_id;
+
+	bool seat_removed_called;
+	sysarg_t seat_removed_seat_id;
+
+	bool seat_changed_called;
+	sysarg_t seat_changed_seat_id;
+
+	fibril_condvar_t event_cv;
+	fibril_mutex_t event_lock;
+	dispcfg_srv_t *srv;
+} test_response_t;
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/dispcfg/meson.build
===================================================================
--- uspace/lib/dispcfg/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/dispcfg/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,38 @@
+#
+# Copyright (c) 2023 Jiri Svoboda
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+src = files(
+	'src/dispcfg.c',
+	'src/dispcfg_srv.c',
+	'src/testdc.c'
+)
+
+test_src = files(
+	'test/main.c',
+	'test/dispcfg.c'
+)
Index: uspace/lib/dispcfg/private/dispcfg.h
===================================================================
--- uspace/lib/dispcfg/private/dispcfg.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/dispcfg/private/dispcfg.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,61 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libdispcfg
+ * @{
+ */
+/** @file
+ */
+
+#ifndef _LIBDISPCFG_PRIVATE_DISPCFG_H_
+#define _LIBDISPCFG_PRIVATE_DISPCFG_H_
+
+#include <async.h>
+#include <fibril_synch.h>
+#include <stdbool.h>
+
+/** Display configuration session structure */
+struct dispcfg {
+	/** Session with display configuration service */
+	async_sess_t *sess;
+	/** Callbacks */
+	dispcfg_cb_t *cb;
+	/** Calback argument */
+	void *cb_arg;
+	/** Synchronize access to display configuration object */
+	fibril_mutex_t lock;
+	/** @c true if callback handler terminated */
+	bool cb_done;
+	/** Signalled when cb_done or ev_pending is changed */
+	fibril_condvar_t cv;
+};
+
+#endif
+
+/** @}
+ */
